//###################################################################
// Fms to Mid version 1.1 (Octobre 2001).
// Copyright (c) Asher256 2001
//
// 
// Url:   https://qbworld.asher256.com/fmsong.php
//###################################################################

#include "unistd.h"        // __file_exists()
#include "mystring.h"      // Gestion de chaine avance
#include "fmlib.h"         // Librairie FmLib++ de musique.
#include "fms2mid.h"       // Fonctions principales de conversion FMS en MIDI

int main(int argc,char *argv[])
{
        short i,j,k;

        if(argc>=3)
         {
          //Message de bienvenue
          for(i=3;i<argc;i++)
           {
                trim(argv[i]);
                lcase(argv[i]);

                if(strcmp(argv[i],"/noprint")==0)          //si MANUAL VOLUME
                                   noprint = 1;
           }
         }

         if(!noprint)
                  printf("%s",bienvenue);

        //prend les arguments
        get_arguments(argc,argv);       //Prend les arguments

        //teste si les fichiers INI sont existants
        test_if_ini_exist(argv[0]);

        //initialisation
        lecture_ini();          //Lecture des options du fichier *.INI
        init();                 //initialisation, allocation et ouverture des fichiers
        write_header();         //Ecrit le header du fichier *.MID
        make_instruments();     //met tout les instruments qui sont dans le FMS
                                //dans la table "midi_instruments()"

        //----------- Affiche quelques Infos sur le FMS et le MIDI ---------
        if(!noprint)
         {
             printf("Fms: \"%s\" Par %s\n",musique->titre,musique->auteur);
             printf("Commentaire: \"%s\"\n",musique->commentaire);
             printf("Midi Volumes: ");
             for(i=0;i<8;i++)
                     printf("%i ",volume[i]);        //affiche le volume
             CRLF();
             printf("Instruments: ");
             for(i=0;i<8;i++)
               {
                        if(musique->ins[i].iname[0]!=0)
                                    musique->ins[i].iname[0] = cucase(musique->ins[i].iname[0]);

                        printf("%s ",musique->ins[i].iname);    //affiche l'instrument
              }
             CRLF();
             printf("Mode: ");
             if(special==1)
                           printf("Special\n");
             else
                           printf("Normal\n");

             CRLF();
         }
         printf("Compilation de \"%s\" dans \"%s\"...\n",file_source,file_destination);
        //---------- Fin de affiche quelques infos sur FMS --------------

        //conversion du fichier FMS en fichier MIDI
        FMS2MID();

        return 0;       // Quitte le programme
}


