//###################################################################
// Header du programme Fms2Mid "initialisation".
// Copyright (c) Asher256 2001
//
// 
// FmSong:  https://qbworld.asher256.com/fmsong.php
//###################################################################
#ifndef __fms2mid__
#define __fms2mid__

#include <stdlib.h>
#include "mystring.h"
#include "fmlib.h"

char percussi[] =   {0,0,0,0,0,0,0,0};                //les channels de percussion si true
char percu_note[] = {0,0,0,0,0,0,0,0};                //les notes de percussion

char enabled[] = {1,1,1,1,1,1,1,1};     //all_channels.enabled

char xins [] = {-1,-1,-1,-1,-1,-1,-1,-1};       //les instruments dans l'option /ins

char noprint = 0;       //l'option /noprint

//Options
char mvol = 0;          //par defaut volume automatique dans le fichier INI
char noinput = 0;       //par defaut il y a input

char *path = (char *) 0;

//--- Declarations de SUB'S -----//
void close_files(void);
void open_files(void);
void bye(void);
void init(void);

//----------- VARIABLES PRINCIPALES --------------//
char *message =
"Syntaxe de Fms2Mid:
         ----------------------------------------------------------------
             Fms2mid.exe <source.fms> <cible.mid> /option1 /option2...
         ----------------------------------------------------------------
Options:
            /noinput   Ne demande pas la confirmation d'crasement du fichier
                       midi ou un Instrument s'il ne le trouve pas.
            /volume    Spcifie le volume de chaque channel vous devez mettre
                       le volume de chaque channel aprs cette commande
                       spars par des virgules (8 channels).
                       \"x\" c'est le volume par dfaut de Fms2Mid
            /mode      Le mode \"normal\" ou \"special\" special (par dfaut)
            /ins       Comme \"volume\" vous devez spcifier les 8 numros
                       d'instruments dans le GENERAL MIDI et \"x\" c'est
                       l'instrument par dfaut du fichier FMS.
            /noprint   n'affiche rien, sauf les erreurs...
            /enabled   Les 8 channels s'il sont Enabled, 0 pour FALSE, 1 pour
                       TRUE, spars par des virgules (comme volume).
Astuce:
            Si vous mettez dans le camp \"cible\" -default Fms2Mid compilera
            Automatiquement votre FMS en MIDI change l'extention *.fms en *.mid
";

char *bienvenue =
"Fms2Mid version 2.0, Copyright (c) Asher256 2001

";

char *ini1 = "fms_ins.ini";
FMS *musique = (FMS *) 0;
char file_source[257],file_destination[257];
int file=0;    //fichier source *.fms

//mapping pour convertir une note FMS en note MIDI
char notemap[] = {
                   0, 2,  4, 5 ,7  ,9  ,11,
                   1, 3, -1, 6 ,8  ,10 ,-1
                 };

unsigned char zero = 0;                  //un zero
unsigned long lenght_of_track = 0;       //le lenght du track
unsigned long pos_lenght_of_track=0;     //la position dans le fichier de lenght of track

char header[] = {'M','T','h','d',00,00,00,06}; //le header principal d'un midi
char track_header[] = {'M','T','r','k'};       //le header du track
short len_header = 8;
short len_header2 = 4;
short midi_format = 0;    //format MULTIPLE TRACK ASYNCRO...
char end_of_rien[] = {0xFF,0x2F};                                  // :)
char max_track = 1;                                                //Le nombre maximum de tracks
char end_of_track[] = {00,0xFF,0x2F};                              //Event qui marque le fin du track
short principal_deltatime = 145;                                    //le delta time principal

unsigned char volume[] = {127,127,127,127,127,127,127,127};    //le max de volume dans les channels

char special = 1;	//Option special FmSong avec octave plus fine

//les instruments
unsigned char midi_instruments[] = {0,0,0,0,0,0,0,0};

//#######################################################
// Lit les options dans le fichier *.ini
//#######################################################
void lecture_ini(void)
{
	/*char buffer[256];
        char lecture[60];               //la valeur du volume
        char vol;
        short i;*/

	//strcpy(buffer,path);
        //strcat(buffer,"\\fms2mid.ini");
}

//########################################################
// Sub se dclanche quand on quitte le programme "atexit"
//########################################################
void bye(void)
{
        if(musique!=0)
            {
                freefms(musique);  //desallocation de musique
                free(musique);
            }
}

//########################################################
// Ouverture MIDI en criture.
//########################################################
void open_files(void)
{
        int ret;
        ret = loadfms(musique,file_source);
        if(ret)
          {
                printf("Erreur dec chargement du FMS \"%s\": \"%s\"...\n",file_source,loadfms_error[ret-1]);
                exit(1);
          }
        //Cree un fichier MIDI et l'ouvre en WRITE.
        file = open(file_destination, O_BINARY|O_CREAT|O_WRONLY|O_TRUNC,0777);
        if(file==-1)
          {
                printf("Erreur dans l'ouverture du fichier MIDI \"%s\"...\n",file_destination);
                printf("Le disque peut tre plein, ou protg en criture...\n");
                close(file);
                exit(1);
          }
}

//########################################################
// Fermeture des fichiers
//########################################################
void close_files(void)
{
        close(file);
}

//########################################################
// Initialisation du programme
//########################################################
void init(void)
{
        atexit(bye);
        musique = (FMS *) malloc(sizeof(FMS)*1);
        if(!musique)
          {
                printf("Pas assez de mmoire pour l'allocation...\n");
                exit(1);
          }
        trim(musique->titre);   //enlve les espaces  gauche et  droite
        trim(musique->auteur);  //dans titre et auteur
        trim(musique->commentaire);  //et commantaire
        open_files();
}

//########################################################
// Prend des arguments ARGC et ARGV les fichier
//########################################################
void get_arguments(int argc,char **argv)
{
        short i,j,pos_options = 0;
        char buffer[256];
        char buffer2[256];
        char buffer3[256];
        short percussi_actuel = 0;
        int temp;

        //Prend les fichier depuis *ARGV[]
        if(argc<=1) //si pas de fichier
         {
                printf("%s",message);
                exit(1);
         }

        //Met les fichier en place
        strcpy(file_source,argv[1]);

        if(!__file_exists(file_source))
         {
                printf("Le FMS \"%s\" n'existe pas...\n",file_source);
                exit(1);
         }

        //teste si c'est un fichier *.MID
        if(strlen(file_source)>4)
            {
               substr(buffer,file_source,strlen(file_source)-4,4);
               if(strcmp(buffer,".mid")==0)
                {
                        printf("Erreur le fichier \"%s\" n'est pas un FMS...\n",file_source);
                        exit(1);
                }
            }

        if(argc==2)     //si pas de fichier cible
         {
                printf("Vous devez spcifier le fichier cible...\n");
                exit(1);
         }

        if(argc>2)     //si pas de fichier source
         {
                strcpy(file_destination,argv[2]);
                lcase(file_destination);
                if(file_destination[0] == '/')
                 {
                        printf("Mettre les options aprs le fichier cible *.mid et non pas dans ce dernier...\n");
                        exit(1);
                 }

                if(strcmp(file_destination,"-default")==0)      //si option default alors il met le FMS en MIDI
                  {
                           changer_ext(file_source,file_destination,"mid");    // l'extention .mid

                  }
         }

         //Maintenant il prend les options
         for(i=3;i<argc;i++)
          {
                trim(argv[i]);
                lcase(argv[i]);

                if(strcmp(argv[i],"/mode")==0)          //si MANUAL VOLUME
                      {
                               i++;

                               if(!(i<argc))
                                   {
                                     printf("Erreur dans l'option \"/mode\" vous devez spcifier le mode...\n");
                                     exit(1);
                                   }

                               trim(argv[i]);
                               lcase(argv[i]);
                               if(strcmp(argv[i],"special")==0)
                                                                  special = 1;
                               else if(strcmp(argv[i],"normal")==0)
                                                                  special = 0;
                               else
                                {
                                 printf("Erreur dans l'option \"/mode\" le mode \"%s\" est incorrect...\n",argv[i]);
                                 exit(1);
                                }

                               continue;
                      }
                else if(strcmp(argv[i],"/ins")==0)          //si MANUAL INSTRUMENT
                      {
                          i++;  //prend ce qui est aprs cette commande
                          if(!(i<argc))
                            {
                                printf("Erreur dans l'option \"/ins\" vous devez spcifier les instruments...\n");
                                exit(1);
                            }
                          if(maxsplit(argv[i],",")==0)
                           {
                                printf("Erreur dans l'option \"/ins\" vous devez spcifier au moin 1 instrument...\n");
                                exit(1);
                           }
                          if(maxsplit(argv[i],",")>8)
                           {
                                printf("Erreur dans l'option \"/ins\" Pas plus de 8 instruments...\n");
                                exit(1);
                           }
                          for(j=0;j<maxsplit(argv[i],",");j++)  //met les instruments
                           {
                               mysplit(buffer2,argv[i],j,",");      //split le groupe d'instrument  l'instrument actuel
                               mysplit(buffer,buffer2,0,"-");       //split maintenant l'instrument avec la percussion
                               trim(buffer);                        //trim
                               lcase(buffer);                       //minuscule

                               mysplit(buffer3,buffer2,1,"-");   //la percussion
                               trim(buffer3);
                               lcase(buffer3);

                               //si percussi <> "" et percussi[0] != 'x'
                               if(strcmp(buffer3,"")!=0 && buffer3[0]!='x')        //si pas vide
                               {
                                        percussi[j] = 1;        //true
                                        percu_note[j] = (unsigned char)atoi(buffer3);
                               }

                               if(buffer[0]!='x')
                                            {
                                             if(atoi(buffer)>127) strcpy(buffer,"127");
                                               xins[j] = (unsigned char)atoi(buffer);
                                            }
                               else
                                            xins[j] = -1;

                           }

                          continue;
                      }
                else if(strcmp(argv[i],"/enabled")==0)          //si MANUAL INSTRUMENT
                      {
                          i++;  //prend ce qui est aprs cette commande
                          if(!(i<argc))
                            {
                                printf("Erreur dans l'option \"/enabled\" vous devez spcifier un channel...\n");
                                exit(1);
                            }
                          if(maxsplit(argv[i],",")==0)
                           {
                                printf("Erreur dans l'option \"/enabled\" vous devez spcifier au moin 1 channel...\n");
                                exit(1);
                           }
                          if(maxsplit(argv[i],",")>8)
                           {
                                printf("Erreur dans l'option \"/enabled\" Pas plus de 8 channels...\n");
                                exit(1);
                           }
                          for(j=0;j<maxsplit(argv[i],",");j++)  //met les volumes
                           {
                               mysplit(buffer,argv[i],j,",");
                               trim(buffer);
                               lcase(buffer);
                               if(buffer[0]!='x')       //si pas de "x"
                                    enabled[j] = (unsigned char)atoi(buffer);   //met le enabled
                           }

                      }
                else if(strcmp(argv[i],"/noprint")==0)          //no print
                                                  noprint = 1;
                else if(strcmp(argv[i],"/volume")==0)          //si MANUAL VOLUME
                      {
                          i++;  //prend ce qui est aprs cette commande
                          if(!(i<argc))
                            {
                                printf("Erreur dans l'option \"/volume\" vous devez spcifier les volumes...\n");
                                exit(1);
                            }
                          if(maxsplit(argv[i],",")==0)
                           {
                                printf("Erreur dans l'option \"/volume\" vous devez spcifier au moin 1 channel...\n");
                                exit(1);
                           }
                          if(maxsplit(argv[i],",")>8)
                           {
                                printf("Erreur dans l'option \"/volume\" Pas plus de 8 channels...\n");
                                exit(1);
                           }
                          for(j=0;j<maxsplit(argv[i],",");j++)  //met les volumes
                           {
                               mysplit(buffer,argv[i],j,",");
                               trim(buffer);
                               lcase(buffer);
                               if(buffer[0]!='x')
                                      {
                                            if(atoi(buffer)>127) strcpy(buffer,"127");

                                            volume[j] = (unsigned char)atoi(buffer);
                                      }
                           }

                      }
                else if(strcmp(argv[i],"/noinput")==0)  //si NOINPUT
                         noinput = 1;
                else    //si une commande pas reconnue
                 {
                        printf("La commande \"%s\" n'est pas reconnue par Fms2Mid...\n",argv[i]);
                        exit(1);
                 }
          }

        //si le fichier existe
        if(__file_exists(file_destination) && noinput==0)
         {
                printf("Le fichier \"%s\" existe dja... l'craser [O/N]? ",file_destination);
                if(choice("o,n")==1)            //s'il choisis non
                                  exit(0);

                CRLF();
         }


}

//########################################################
// Teste si les fichier *.INI existent
//########################################################
void test_if_ini_exist(char *argv0)
{
        char *buffer = (char *) malloc(1);
        //cherche si les fichiers INI existent
        path = dirname(argv0);

        if(!path)
           { printf("Pas assez de mmoire pour executer le programme...\n");
             exit(1);  }

        buffer = realloc(buffer,strlen(path)+strlen(ini1)+1);
        if(!buffer)
           { printf("Pas assez de mmoire pour executer le programme...\n");
             free(path);
             exit(1);  }

        sprintf(buffer,"%s\\%s",path,ini1);
        if(!__file_exists(buffer))
          {
             printf("Le fichier ini: \"%s\" est introuvable...\n",buffer);
             free(path);
             free(buffer);
             exit(1);
          }

        free(buffer);
}

#endif

